/**
 * Class DieTest is a driver class for testing the
 * complete functionality of the Die class.
 *
 * CS103 - Homework 6 Solution
 *
 * @author  Randy Phillips
 * @version 1.0
 */
public class DieTest
{
  public static void main(String[] args)
  {
    /** Standard Cases **/

    Die sixSidedDie    = new Die(),      // Die object intialized to the default values
        twelveSidedDie = new Die(12),    // Die object w/ number of faces = 12
        twentySidedDie = new Die(20,10); // Die object w/ number of faces = 20 and current value = 10

    // test the six sided die
    System.out.println("The six sided die has a value of " + sixSidedDie.readDie());
    sixSidedDie.rollDie();
    System.out.println("After rolling, the six sided die now has a value of " + sixSidedDie.readDie());
    System.out.println("After rolling again, the six sided die now has a value of " + sixSidedDie.rollDie());

    System.out.println();

    // test the twelve sided die
    System.out.println("The twelve sided die has a value of " + twelveSidedDie.readDie());
    twelveSidedDie.rollDie();
    System.out.println("After rolling, the twelve sided die now has a value of " + twelveSidedDie.readDie());
    System.out.println("After rolling again, the twelve sided die now has a value of " + twelveSidedDie.rollDie());

    System.out.println();

    // test the twenty sided die
    System.out.println("The twenty sided die has a value of " + twentySidedDie.readDie());
    twentySidedDie.rollDie();
    System.out.println("After rolling, the twenty sided die now has a value of " + twentySidedDie.readDie());
    System.out.println("After rolling again, the twenty sided die now has a value of " + twentySidedDie.rollDie());

    System.out.println();

    /** Error Cases **/

    Die zeroSidedDie     = new Die(0),
        impossibleDieOne = new Die(5,10),
        impossibleDieTwo = new Die(-5,0);
    
    System.out.println(
      "The zero sided die is corrected to a six sided die with a value of " + zeroSidedDie.readDie()
    );
    System.out.println(
      "The first impossible die is corrected to a ten sided die with a value of " + impossibleDieOne.readDie()
    );
    System.out.println(
      "The second impossible die is corrected to a six sided die with a value of " + impossibleDieTwo.readDie()
    );
  }
}